﻿EnableExplicit

#MAC_LAN = "00-10-FF-E0-24-A2" ; Мак адрес сетевой карты.

Structure TMibIfRow Align #PB_Structure_AlignC
  wszName.u[256]
  dwIndex.l 
  dwType.l 
  dwMtu.l 
  dwSpeed.l 
  dwPhysAddrLen.l 
  bPhysAddr.a[8] 
  dwAdminStatus.l 
  dwOperStatus.l 
  dwLastChange.l 
  dwInOctets.l 
  dwInUcastPkts.l 
  dwInNUCastPkts.l 
  dwInDiscards.l 
  dwInErrors.l 
  dwInUnknownProtos.l 
  dwOutOctets.l 
  dwOutUCastPkts.l 
  dwOutNUCastPkts.l 
  dwOutDiscards.l 
  dwOutErrors.l 
  dwOutQLen.l 
  dwDescrLen.l 
  bDescr.a[256] 
EndStructure 

Structure TMibIfArray Align #PB_Structure_AlignC
  Array.TMibIfRow[513] 
EndStructure 

Structure TMibIfTable Align #PB_Structure_AlignC
  dwNumEntries.l 
  Table.TMibIfArray 
EndStructure 

#IF_TYPE_OTHER =1; неизвестный сетевой интерфейс; 
#IF_TYPE_ETHERNET_CSMACD =6 ;– Ethernet; 
#IF_TYPE_ISO88025_TOKENRING =9 ; Token ring; 
#IF_TYPE_PPP =23 ;– PPP; 
#IF_TYPE_SOFTWARE_LOOPBACK =24 ;– Lookback; 
#IF_TYPE_ATM =37 ;– ATM; 
#IF_TYPE_TUNNEL =131 ;– tunnel; 
#IF_TYPE_IEEE1394 =144 ; IEEE 1394. 


Structure TMac  Align #PB_Structure_AlignC
  Array.a[8] 
EndStructure 


Structure Info Align #PB_Structure_AlignC
  AllTrafic.q
  All_InTrafic.q
  All_OutTrafic.q
  VspOknoState.a
  VspOknoType.a
  PrOkno.a
  AutoRunState.a
  LimitState.a
  Limit.l
  LimitTypeTrafic.a
  LimitCountMessage.l
  VspTime1.a
  VspTime2.a
  TypeTrafic.a
  
  InTraffSave.q
  OutTraffSave.q
  
  List Average_InSpeed.l()
  List Average_OutSpeed.l()
EndStructure


Structure AnimWin ; Анимация информационного окна в фоновом режиме
  AnimState.a  ; 0 - плавно отображаем окно; 1 - плавно скрываем окно
  AnimMax.a    ; Максимальная непрозрачность окна
  Window.i     ; Идентификатор окна
EndStructure

Define Connect_1=0 ; Признак первого соединения. Его нужно пропустить

Define SavePref_Flag=#False

Define ProgInfo.Info
Define InfoWin.AnimWin
Define AnimateWindow_Thread_State

Define PathTempDir.s=GetTemporaryDirectory() ; Путь к временной папке
Global HideInfoWindowState.a=1 ; 0 - всплывающее окно отображается; 1 - не отображается


Declare SaveInfo(*ProgInfo.Info)


#NIN_BALLOONSHOW=$402 
#NIN_BALLOONHIDE=$403 
#NIN_BALLOONTIMEOUT =$404 
#NIN_BALLOONUSERCLICK=$405 
#NOTIFYICON_VERSION = $3

Structure NOTIFYICONDATA_95 Align #PB_Structure_AlignC
  cbSize.l
  hwnd.i 
  uID.l 
  uFlags.l
  uCallbackMessage.i 
  hIcon.i 
  szTip.c[64] 
EndStructure 
Structure NOTIFYICONDATA_2K Extends NOTIFYICONDATA_95 Align #PB_Structure_AlignC
  szTipEx.c[64] 
  dwState.l
  dwStateMask.l 
  szInfo.c[256] 
  StructureUnion 
    uTimeout.i 
    uVersion.i 
  EndStructureUnion 
  szInfoTitle.c[64]
  dwInfoFlags.l
EndStructure


Procedure SysTrayIconBalloon(Tray, WindowID, Title.s, Message.s, TimeOut, TypeIcon) 
; Tray     - идентификатор значка в трее
; WindowID - Системный идентификатор окна
; Title    - текст в заголовке баллона
; Message  - текст в баллоне
; TimeOut  - Время (в миллисекундах) отображения баллона
; TypeIcon - тип значка #NIIF_NONE #NIIF_INFO #NIIF_WARNING #NIIF_ERROR #NIIF_USER

  Protected nid.NOTIFYICONDATA_2K 
  nid\cbSize      = SizeOf(NOTIFYICONDATA_2K)
  nid\uVersion = #NOTIFYICON_VERSION
  Shell_NotifyIcon_(#NIM_SETVERSION, @nid)
  nid\uCallbackMessage=#PB_Event_SysTray
  nid\uID         = Tray
  nid\hwnd        = WindowID
  nid\dwInfoFlags = TypeIcon;#NIIF_INFO
  nid\uFlags      = #NIF_INFO
  nid\uTimeout    = TimeOut
  nid\dwState = #NIS_SHAREDICON
  PokeS(@nid\szInfo, message, 256) 
  PokeS(@nid\szInfoTitle, title, 64)
  
  ProcedureReturn Shell_NotifyIcon_(#NIM_MODIFY, @nid) 
  
EndProcedure

Procedure Test_TrayIcon(Tray, WindowID)
; Tray - идентификатор значка в трее
; WindowID - системный идентификатор окна, к которому привязан значок
; Результат - 1 - значок есть; 0 - значка нет

  Protected nid.NOTIFYICONDATA_2K 
  nid\cbSize      = SizeOf(NOTIFYICONDATA_2K)
  nid\uID         = Tray
  nid\hwnd        = WindowID
  nid\uFlags      = #NIF_STATE
  nid\dwStateMask = #NIS_HIDDEN
  ProcedureReturn Shell_NotifyIcon_(#NIM_MODIFY, @nid) 
EndProcedure

Structure IconButton 
  oldWndProc.i 
  icon.i 
EndStructure 
#BS_LEFT         =    $00000100 
#BS_RIGHT        =    $00000200 
#BS_TOP          =    $00000400 
#BS_BOTTOM       =    $00000800 

#DI_NORMAL       =    $00000003 

#iconsize        =    16 

Procedure DrawIconOnButton(hWnd,*p.IconButton,clicked) 
  Protected hDC, rect.RECT, style, x, y
  
  hDC = GetDC_(hWnd) 
  GetClientRect_(hWnd,rect) 
  style = GetWindowLongPtr_(hWnd,#GWL_STYLE) 
  If style & #BS_LEFT 
    x = rect\right - 10 - #iconsize 
    y = rect\bottom/2 - #iconsize/2 
  ElseIf style & #BS_RIGHT 
    x = 10 
    y = rect\bottom/2 - #iconsize/2 
  ElseIf style & #BS_TOP 
    x = rect\right/2 - #iconsize/2 
    y = rect\bottom - 5 - #iconsize 
  ElseIf style & #BS_BOTTOM 
    x = rect\right/2 - #iconsize/2 
    y = 5 
  EndIf 
  If clicked 
    x+1 
    y+1 
  EndIf 
  If GetWindowLongPtr_(hWnd,#GWL_STYLE) & #WS_DISABLED 
    DrawState_(hDC,GetStockObject_(#LTGRAY_BRUSH),0,*p\icon,0,x+1,y+1,#iconsize,#iconsize,#DST_ICON|#DSS_MONO) 
    DrawState_(hDC,GetStockObject_(#GRAY_BRUSH)  ,0,*p\icon,0,x  ,y  ,#iconsize,#iconsize,#DST_ICON|#DSS_MONO) 
  Else 
    DrawIconEx_(hDC,x,y,*p\icon,#iconsize,#iconsize,1,0,#DI_NORMAL) 
  EndIf 
  ReleaseDC_(hWnd,hDC) 
EndProcedure 


Procedure IconButtonProc(hWnd,Msg,wParam,lParam) 
  Protected *p.IconButton, retval, state, clicked
  Protected rect.RECT, pt.POINT
  
  *p = GetWindowLongPtr_(hWnd,#GWL_USERDATA) 
  If *p 
    If *p\oldWndProc 
      retval = CallWindowProc_(*p\oldWndProc,hWnd,Msg,wParam,lParam) 
      If Msg = #WM_PAINT And *p\icon 
        state = SendMessage_(hWnd,#BM_GETSTATE,0,0) 
        If state = #BST_CHECKED Or state=#BST_PUSHED 
          clicked=1 
        EndIf 
        DrawIconOnButton(hWnd,*p,clicked) 
      ElseIf Msg = #WM_LBUTTONDOWN Or Msg = #WM_LBUTTONDBLCLK 
        DrawIconOnButton(hWnd,*p,1) 
      ElseIf Msg = #WM_LBUTTONUP 
        DrawIconOnButton(hWnd,*p,0) 
      ElseIf Msg = #WM_MOUSEMOVE And wParam = #MK_LBUTTON 
        GetWindowRect_(hWnd,rect) 
        GetCursorPos_(pt) 
        If PtInRect_(@rect,pt\x|(pt\y<<32)) 
          clicked = 1 
        EndIf 
        DrawIconOnButton(hWnd,*p,clicked) 
      EndIf 
      ProcedureReturn retval 
    EndIf 
  EndIf 
  ProcedureReturn DefWindowProc_(hWnd,Msg,wParam,lParam) 
EndProcedure 


Procedure IconButtonGadget(Gadget,x,y,w,h,text$,icon,flags) 
  Protected btn, *p.IconButton
  btn = ButtonGadget(Gadget,x,y,w,h,text$,flags) 
  If btn 
    *p = AllocateMemory(SizeOf(IconButton)) 
    If *p 
      SetWindowLongPtr_(GadgetID(Gadget),#GWL_USERDATA,*p) 
      *p\icon       = icon 
      *p\oldWndProc = SetWindowLongPtr_(GadgetID(Gadget),#GWL_WNDPROC,@IconButtonProc()) 
    Else 
      FreeGadget(Gadget) 
      btn=0 
    EndIf 
  EndIf 
  ProcedureReturn btn 
EndProcedure 


Procedure$ GetMAC(*Value.TMac, Length) 
  Protected Result$, i
  
  If Length 
    For i = 0 To Length-2 
      Result$ + RSet(Hex(*Value\Array[i]),2,"0") + "-" 
    Next 
    Result$ + RSet(Hex(*Value\Array[Length-1]),2,"0") 
  Else 
    Result$ = "00-00-00-00-00-00" 
  EndIf 
  
  ProcedureReturn Result$ 
EndProcedure 

Procedure Traffic(*TrafDownload.Long, *TrafUpload.Long, *Speed.Long) 
  Protected TrafDownload.l=0, TrafUpload.l=0,Speed.l=0
  Protected i, Size, Table.TMibIfTable, Res = #False
  
  
  Size = SizeOf(TMibIfTable) 
  If GetIfTable_(@Table,@Size,#False) = 0 
    For i = 0 To (Table\dwNumEntries - 1) 
      If GetMAC(@Table\Table\Array[i]\bPhysAddr, Table\Table\Array[i]\dwPhysAddrLen)=#MAC_LAN
        *TrafDownload\l = Table\Table\Array[i]\dwInOctets
        *TrafUpload\l = Table\Table\Array[i]\dwOutOctets
        *Speed\l = Table\Table\Array[i]\dwSpeed
        Res = #True
        Break
      EndIf 
    Next 
  EndIf
  
  ProcedureReturn Res
EndProcedure 


Procedure PosWinInfo(Window)
  Protected TrayWnd, TrayNofifyWnd
  Protected Win_x, Win_y, win.RECT
  
  If IsWindow(Window)>0
    TrayWnd       = FindWindow_("Shell_TrayWnd", 0)
    TrayNofifyWnd = FindWindowEx_(TrayWnd, 0, "TrayNotifyWnd", 0)
    GetWindowRect_(TrayNofifyWnd, @win) ; Узнаём высоту трея
    
    Win_x=GetSystemMetrics_(#SM_CXSCREEN)-WindowWidth(Window)-4
    Win_y=GetSystemMetrics_(#SM_CYSCREEN)-(win\bottom-win\top)-WindowHeight(Window)-4
    ResizeWindow(Window, Win_x, Win_y, #PB_Ignore, #PB_Ignore) 
  EndIf
EndProcedure


Procedure AnimateWindow_Thread(*InfoWin.AnimWin)
  Shared AnimateWindow_Thread_State
  Protected Win, x, id, i
  
  AnimateWindow_Thread_State=1
  Win=*InfoWin\Window
  x=*InfoWin\AnimMax
  If IsWindow(Win)
    
    id=WindowID(Win)
    
    If *InfoWin\AnimState=0 ; плавно отображаем окно
      
      PosWinInfo(Win)
      
      SetLayeredWindowAttributes_(ID, 2, i, 2)
      HideWindow(Win, 0)
      
      For i=2 To x Step 8
        SetLayeredWindowAttributes_(id, 0, i, 2)
        Delay(10)
      Next i
      Delay(20)
      SetLayeredWindowAttributes_(id, 0, x, 2)
      Delay(20)
      SetLayeredWindowAttributes_(id, 0, x, 2)
      
    Else                    ; плавно скрываем окно
      
      For i=x To 2 Step -8
        SetLayeredWindowAttributes_(id, 0, i, 2)
        Delay(10)
      Next i
      HideWindow(Win,1)
      SetLayeredWindowAttributes_(id, 0, x, 2)
      
    EndIf
    
  EndIf
  AnimateWindow_Thread_State=0
EndProcedure


Procedure.l Add_AverageList_Long(List MyList.l(), Add.l, MaxList.l) ; Добавляет новый элемент в список, удаляем последний элемента, если число элементов превысило MaxList и вычисняет средне арехметическое всех элементов.
  Protected Result.l, x.l, i, Size
  
  Size = ListSize(MyList())
  If Size>MaxList
    LastElement(MyList())
    For i=Size-1 To MaxList Step -1
      DeleteElement(MyList())
    Next i
    Size = ListSize(MyList())
  EndIf
  
  x=#False
  If Size<MaxList
    FirstElement(MyList())
    If InsertElement(MyList())
      x=#True
      Size + 1
    EndIf
  Else
    x=#True
    If Size=MaxList
      LastElement(MyList())
      MyList()=0
      MoveElement(MyList(), #PB_List_First)
    EndIf
  EndIf
  
  
  If x=#True
    FirstElement(MyList())
    MyList() = Add
  EndIf
  
  
  Result=0 : x=0
  ForEach MyList()
    Result + MyList()
    x + 1
  Next
  
  Result / x
  
  ProcedureReturn Result
EndProcedure


Procedure CountTraf()
  Static TrayIconState.a, OldInput.l, OldOutput.l, CountSek, CountTimeWin_Hide, CountTimeWin_Hide_1, sSaveTime
  Static InBytes.q=0, OutBytes.q=0
  Shared ProgInfo, HideInfoWindowState, AnimateWindow_Thread_State, Connect_1
  Protected InfoWin.AnimWin, Limit.q, Text.s="", Input.l, Output.l, Speed.l, Temp.l, Time, InSpeed.l, OutSpeed.l
  Protected dwConnectionTypes=#INTERNET_CONNECTION_MODEM | #INTERNET_CONNECTION_LAN | #INTERNET_CONNECTION_PROXY 
  Protected PropuskPlus, g, TrafAll.q, PicInp.l, PicOut.l
  
  InfoWin\AnimMax=ProgInfo\PrOkno
  InfoWin\Window=1
  
  If Connect_1=0
    Connect_1=1
    Traffic(@OldInput, @OldOutput,@Speed)
    ProcedureReturn
  EndIf
     
    
    PropuskPlus=0
    If TrayIconState<>1 ; Признак отсутствия связи при предыдущей проверке
      TrayIconState=1
      PropuskPlus=1
      ChangeSysTrayIcon(1, ImageID(1))
      SetGadgetText(32,"0")
      SetGadgetText(34,"0")
      SetGadgetText(36,"0")
      SetGadgetText(38,"0")
    EndIf
    
    Traffic(@Input, @Output,@Speed) 
    
    Temp = Input-OldInput
    If Temp>0
      InSpeed = Temp
    EndIf
    
    Temp = Output-OldOutput
    If Temp>0
      OutSpeed = Temp
    EndIf
    
    ; Отображаем всплывающее окно
    If ProgInfo\VspOknoType=1 Or (ProgInfo\VspOknoType=2 And (InSpeed>=1000 Or OutSpeed>=1000))
      If HideInfoWindowState<>0 And AnimateWindow_Thread_State<>1
        If CountTimeWin_Hide_1>=ProgInfo\VspTime1
          InfoWin\AnimState=0
          If CreateThread(@AnimateWindow_Thread(), @InfoWin)
            HideInfoWindowState=0 : CountTimeWin_Hide_1=0
          EndIf
        Else
          CountTimeWin_Hide_1+1
        EndIf
      EndIf    
      
    ElseIf ProgInfo\VspOknoType=2 And (InSpeed<1000 Or OutSpeed<1000)
      If HideInfoWindowState<>1 And AnimateWindow_Thread_State<>1
        If CountTimeWin_Hide_1>=ProgInfo\VspTime2
          InfoWin\AnimState=1
          If CreateThread(@AnimateWindow_Thread(), @InfoWin)
            HideInfoWindowState=1 : CountTimeWin_Hide_1=0
          EndIf
        Else
          CountTimeWin_Hide_1+1
        EndIf
      EndIf
    EndIf
    
    
    Select ProgInfo\LimitTypeTrafic
      Case 0
        Limit=ProgInfo\AllTrafic
        g=46
      Case 1
        Limit=ProgInfo\All_InTrafic
        g=42
      Case 2
        Limit=ProgInfo\All_OutTrafic
        g=44
      Default
        Limit=0
        g=-4
    EndSelect
    
    
    
    If InSpeed>100 Or OutSpeed>100
      TrafAll=InSpeed+OutSpeed
      If PropuskPlus=0
        ProgInfo\AllTrafic=ProgInfo\AllTrafic+TrafAll
        SetGadgetText(46,Str(ProgInfo\AllTrafic/1048576))
        
        
        
        If ProgInfo\LimitState=1 And Limit>0
          
          If ProgInfo\Limit-(ProgInfo\Limit/10) < Limit/1048576 And ProgInfo\LimitCountMessage<1
            SysTrayIconBalloon(1, WindowID(2), "Лимит трафика заканчивается!", "Осталось менее 10% до окончания лимита", 100000, 2) 
            ProgInfo\LimitCountMessage=1
          EndIf
          
          
          If Limit/1048576>ProgInfo\Limit
            SetGadgetColor(48,#PB_Gadget_FrontColor, RGB(227, 6, 1) )
            If IsGadget(g)>0
              SetGadgetColor(g,#PB_Gadget_FrontColor, RGB(173, 5, 1) )
            EndIf
            SetGadgetText(48,Str(Limit/1048576-ProgInfo\Limit))
            
            If ProgInfo\LimitCountMessage<2
              ProgInfo\LimitCountMessage=ProgInfo\Limit+(ProgInfo\Limit/10)
              SysTrayIconBalloon(1, WindowID(2), "Лимит трафика закончился!", "Исчерпан весь лимит - "+Str(ProgInfo\Limit)+" Мб", 100000, 2) 
            ElseIf ProgInfo\LimitCountMessage<Limit/1048576
              ProgInfo\LimitCountMessage=ProgInfo\LimitCountMessage+(ProgInfo\Limit/10) ; Плюс 10% лимита
              SysTrayIconBalloon(1, WindowID(2), "Лимит закончился, теперь вы тлатите за трафик!", "Лимит превышен на "+Str(Limit/1048576-ProgInfo\Limit)+" Мб", 100000, 2) 
            EndIf
            
            
          EndIf
          
        EndIf
      EndIf
      
    EndIf
    
    
    
    If InSpeed>100
      InBytes + InSpeed
      PicInp=Add_AverageList_Long(ProgInfo\Average_InSpeed(), InSpeed, 4) ; Пиковая скорость вх 
      If PropuskPlus=0
        SetGadgetText(32,Str(InBytes/1024))
        If PicInp>1024
          SetGadgetText(36,Str(PicInp/1024))
        Else
          SetGadgetText(36,StrF(PicInp/1024,3))
        EndIf
        ProgInfo\All_InTrafic+InSpeed
        SetGadgetText(42,Str(ProgInfo\All_InTrafic/1048576))
      EndIf 
    Else
      SetGadgetText(36,"0")
    EndIf
    
    OldInput=Input
    
    If OutSpeed>100
      OutBytes + OutSpeed
      PicOut=Add_AverageList_Long(ProgInfo\Average_OutSpeed(), OutSpeed, 4) ; Пиковая скорость исх 
      If PropuskPlus=0
        SetGadgetText(34,Str(OutBytes/1024))
        If PicOut>1024
          SetGadgetText(38,Str(PicOut/1024)) 
        Else
          SetGadgetText(38,StrF(PicOut/1024,3))
        EndIf
        ProgInfo\All_OutTrafic+OutSpeed
        SetGadgetText(44,Str(ProgInfo\All_OutTrafic/1048576))
      EndIf
    Else
      SetGadgetText(38,"0") 
    EndIf
    
    OldOutput=Output 
    
    
    Text="Вх.  "+Str(ProgInfo\All_InTrafic/1048576)+Chr(10)
    Text=Text+"Исх. "+Str(ProgInfo\All_OutTrafic/1048576)+Chr(10)
    Text=Text+"Итого "+Str(ProgInfo\AllTrafic/1048576)
    If ProgInfo\LimitState=1 And Limit>0
      If Limit/1048576>ProgInfo\Limit
        Text=Text+Chr(10)+"----"+Chr(10)
        Text=Text+"Пр. лимита "+Str(Limit/1048576-ProgInfo\Limit)
      EndIf
    EndIf
    
    SysTrayIconToolTip(1, Text)
    
    CountSek+1
    If CountSek>=60*30
      CountSek=0
    EndIf
    
    If sSaveTime=0
      sSaveTime = ElapsedMilliseconds()
    EndIf
    
    Time = ElapsedMilliseconds()
    If Time - sSaveTime > 60000
      sSaveTime = Time
      SaveInfo(@ProgInfo)
    EndIf
    
EndProcedure



Procedure WindowInfo()
  Shared ProgInfo
  Protected Limit.q, w, h, i
  Protected Im1, Im2, Im3, g
  
  If IsWindow(1)>0
    HideWindow(1,0)
    ProcedureReturn
  EndIf
  
  w=280
  h=100
  
  If OpenWindow(1, 10, 10, w, h, "", #PB_Window_Invisible|#PB_Window_BorderLess) 
    CompilerIf #PB_Compiler_Version<430 
      CreateGadgetList(WindowID(1)) 
    CompilerEndIf 
    
    PosWinInfo(1)
    
    Im1=CreateImage(#PB_Any,2,74)
    If StartDrawing(ImageOutput(Im1))
      Box(0, 0, 2, 74 , RGB(57, 209, 181)) 
      StopDrawing()
      ImageGadget(#PB_Any,145,20,2,74,ImageID(Im1))
    EndIf
    
    Im2=CreateImage(#PB_Any,110,1)
    If StartDrawing(ImageOutput(Im2))
      Box(0, 0, 110, 1 , RGB(196, 96, 0)) 
      StopDrawing()
      ImageGadget(#PB_Any,10,57,110,1,ImageID(Im2))
    EndIf
    
    Im3=CreateImage(#PB_Any,110,1)
    If StartDrawing(ImageOutput(Im3))
      Box(0, 0, 110, 1 , RGB(177, 2, 19)) 
      StopDrawing()
      ImageGadget(#PB_Any,158,76,110,1,ImageID(Im3))
    EndIf
    
    
    TextGadget(30,4,2,140,15,"Текущее соединение в Кб") : SetGadgetColor(30,#PB_Gadget_FrontColor, RGB(0, 0, 255) )
    TextGadget(31,4,20,68,15,"Входящий") :    TextGadget(32,74,20,68,15,"")
    TextGadget(33,4,40,68,15,"Исходящий") :   TextGadget(34,74,40,68,15,"")
    TextGadget(35,4,60,68,15,"Вх. скор.") :   TextGadget(36,74,60,68,15,"")
    TextGadget(37,4,80,68,15,"Исход. скор.") : TextGadget(38,74,80,68,15,"")
    SetGadgetColor(32,#PB_Gadget_FrontColor, RGB(143, 4, 114) )
    SetGadgetColor(34,#PB_Gadget_FrontColor, RGB(143, 4, 114) )
    SetGadgetColor(36,#PB_Gadget_FrontColor, RGB(105, 4, 152) )
    SetGadgetColor(38,#PB_Gadget_FrontColor, RGB(105, 4, 152) )
    
    
    TextGadget(40,158,2,108,15,"Общий трафик в Мб") : SetGadgetColor(40,#PB_Gadget_FrontColor, RGB(0, 0, 255) )
    TextGadget(41,154,20,68,15,"Входящий") :     TextGadget(42,220,20,60,15,Str(ProgInfo\All_InTrafic/1048576))
    TextGadget(43,154,40,68,15,"Исходящий") :    TextGadget(44,220,40,60,15,Str(ProgInfo\All_OutTrafic/1048576))
    TextGadget(45,154,60,68,15,"Общий") :    TextGadget(46,220,60,60,15,Str(ProgInfo\AllTrafic/1048576))
    TextGadget(47,154,80,68,15,"Пр. лимита") : TextGadget(48,220,80,60,15,"0")
    SetGadgetColor(42,#PB_Gadget_FrontColor, RGB(34, 92, 78) )
    SetGadgetColor(44,#PB_Gadget_FrontColor, RGB(34, 92, 78) )
    SetGadgetColor(46,#PB_Gadget_FrontColor, RGB(0, 120, 0) )
    
    
    If ProgInfo\LimitState=1 
      Select ProgInfo\LimitTypeTrafic
        Case 0
          Limit=ProgInfo\AllTrafic
          g=46
        Case 1
          Limit=ProgInfo\All_InTrafic
          g=42
        Case 2
          Limit=ProgInfo\All_OutTrafic
          g=44
        Default
          g=-4
          Limit=0
      EndSelect
      
      
      If ProgInfo\Limit<Limit/1048576 And Limit>0
        If IsGadget(g)>0
          SetGadgetColor(g,#PB_Gadget_FrontColor, RGB(173, 5, 1) )
        EndIf
        SetGadgetColor(48,#PB_Gadget_FrontColor, RGB(227, 6, 1) )
        SetGadgetText(48,Str(Limit/1048576-ProgInfo\Limit))
      EndIf
      
    EndIf   
    
    
    SetWindowColor(1,14803425)
    For i=30 To 48
      If IsGadget(i)>0
        SetGadgetColor(i,#PB_Gadget_BackColor,14803425)
      EndIf
    Next i  
    
    
    
    SetWindowLongPtr_(WindowID(1), #GWL_EXSTYLE, $00080000 | #WS_EX_TOOLWINDOW) 
    SetLayeredWindowAttributes_(WindowID(1), 0, ProgInfo\PrOkno, 2)
    SetWindowPos_ (WindowID(1), #HWND_TOPMOST, 0, 0, 0, 0, #SWP_NOMOVE | #SWP_NOSIZE)
    SetWindowLongPtr_( WindowID (1), #GWL_EXSTYLE , GetWindowLongPtr_( WindowID (1), #GWL_EXSTYLE )|#WS_EX_LAYERED|#WS_EX_TRANSPARENT| #WS_DLGFRAME) 
    
  EndIf
EndProcedure


Procedure WindowCallback(WindowID, Message, wParam, lParam)
  Shared SavePref_Flag, ProgInfo
  
  If Message=#WM_QUERYENDSESSION   ; Выключается компьютер.
    SavePref_Flag=2
    SaveInfo(@ProgInfo)
  EndIf
  
  ProcedureReturn #PB_ProcessPureBasicEvents
EndProcedure


Procedure TestFileAndKey()
  Shared PathTempDir
  
  If FileSize(PathTempDir+"TraficMonitor.trf")<0
    If CreatePreferences(PathTempDir+"TraficMonitor.trf")
      WritePreferenceLong("AllTrafic",0)
      WritePreferenceLong("All_InTrafic",0)
      WritePreferenceLong("All_OutTrafic",0)
      ClosePreferences()
    EndIf
  EndIf
  
EndProcedure


Procedure ReadInfo(*ProgInfo.Info)
  Protected Dim Temp.q(3,3)
  Shared PathTempDir
  
  If OpenPreferences(PathTempDir+"TraficMonitor.trf")
    *ProgInfo\AllTrafic=ReadPreferenceQuad("AllTrafic",0)
    *ProgInfo\All_InTrafic=ReadPreferenceQuad("All_InTrafic",0)
    *ProgInfo\All_OutTrafic=ReadPreferenceQuad("All_OutTrafic",0)
    
    ; Отображать полупрозрачное окно (1) или нет (0)
    *ProgInfo\VspOknoState=ReadPreferenceLong("VspOknoState",1)
    ; Отображать полупрозрачное окно (1) или нет (0)
    HideInfoWindowState=ReadPreferenceLong("VspOknoCheck",0)
    ; В каких случаях отображать полупрозрачное окно
    *ProgInfo\VspOknoType=ReadPreferenceLong("VspOknoType",2)
    ; Прозрачность окна
    *ProgInfo\PrOkno=ReadPreferenceLong("PrOkno",200)
    ; Автозагрузка программы (1)
    *ProgInfo\AutoRunState=ReadPreferenceLong("AutoRunState",0)
    ; Контроль лимита включён (1)
    *ProgInfo\LimitState=ReadPreferenceLong("LimitState",0)
    ; Допустимый лимит
    *ProgInfo\Limit=ReadPreferenceLong("Limit",500)
    ; При подсчёте лимита учитывать весь трафик (0), входящий (1) или исходящий (2)
    *ProgInfo\LimitTypeTrafic=ReadPreferenceLong("LimitTypeTrafic",0)
    ; Время в секундах перед отображением информационного окна
    *ProgInfo\VspTime1=ReadPreferenceLong("VspTime1",2)
    ; Время в секундах перед скрытием информационного окна
    *ProgInfo\VspTime2=ReadPreferenceLong("VspTime2",2)
    *ProgInfo\LimitCountMessage=ReadPreferenceLong("LimitCountMessage",0)
    *ProgInfo\TypeTrafic=ReadPreferenceLong("TypeTrafic",0)

    ClosePreferences()
    
    *ProgInfo\InTraffSave=*ProgInfo\All_InTrafic
    *ProgInfo\OutTraffSave=*ProgInfo\All_OutTrafic
    
  EndIf
EndProcedure



Procedure SaveInfo(*ProgInfo.Info)
  Shared PathTempDir, SavePref_Flag
  
  
  If SavePref_Flag Or (*ProgInfo\All_InTrafic-*ProgInfo\InTraffSave>20*1024*1024 Or *ProgInfo\All_OutTrafic-*ProgInfo\OutTraffSave>20*1024*1024)
    
    If OpenPreferences(PathTempDir+"TraficMonitor.trf")
      WritePreferenceQuad("AllTrafic", *ProgInfo\AllTrafic)
      WritePreferenceQuad("All_InTrafic",*ProgInfo\All_InTrafic)
      WritePreferenceQuad("All_OutTrafic",*ProgInfo\All_OutTrafic)
      
      If SavePref_Flag=#True 
        ; Отображать полупрозрачное окно (1) или нет (0)
        WritePreferenceLong("VspOknoState",*ProgInfo\VspOknoState)
        
        ; Отображать полупрозрачное окно (1) или нет (0)
        WritePreferenceLong("VspOknoCheck",HideInfoWindowState)
        
        ; В каких случаях отображать полупрозрачное окно
        WritePreferenceLong("VspOknoType",*ProgInfo\VspOknoType)
        
        ; Прозрачность окна
        WritePreferenceLong("PrOkno",*ProgInfo\PrOkno)
        
        ; Автозагрузка программы (1)
        WritePreferenceLong("AutoRunState",*ProgInfo\AutoRunState)
        
        ; Контроль лимита включён (1)
        WritePreferenceLong("LimitState",*ProgInfo\LimitState)
        
        ; Допустимый лимит
        WritePreferenceLong("Limit",*ProgInfo\Limit)
        
        ; При подсчёте лимита учитывать весь трафик (0), входящий (1) или исходящий (2)
        WritePreferenceLong("LimitTypeTrafic",*ProgInfo\LimitTypeTrafic)
        
        ; Время в секундах перед отображением информационного окна
        WritePreferenceLong("VspTime1",*ProgInfo\VspTime1)
        
        ; Время в секундах перед скрытием информационного окна
        WritePreferenceLong("VspTime2",*ProgInfo\VspTime2)
        
        WritePreferenceLong("LimitCountMessage",*ProgInfo\LimitCountMessage)
        
        WritePreferenceLong("TypeTrafic",*ProgInfo\TypeTrafic)
        
      EndIf
      
      SavePref_Flag=#False
      ClosePreferences()
    EndIf
    
    *ProgInfo\InTraffSave=*ProgInfo\All_InTrafic
    *ProgInfo\OutTraffSave=*ProgInfo\All_OutTrafic
    Debug "Save"
  EndIf
  
EndProcedure

Procedure ProgramAtStartup(State) ; Управление автозагрузкой программы
  Protected valueName$, ProgName.s, GetHandle, hKey
  valueName$=ProgramFilename() 
  ProgName="CountTraffic"
  GetHandle = RegOpenKeyEx_(#HKEY_CURRENT_USER, "Software\Microsoft\Windows\CurrentVersion\Run", 0, #KEY_ALL_ACCESS, @hKey)
  If GetHandle = #ERROR_SUCCESS
    If State=#True
      RegSetValueEx_(hKey, @ProgName, 0, #REG_SZ, @valueName$, StringByteLength(valueName$))
    Else
      RegDeleteValue_(hKey, @ProgName)
    EndIf
    RegCloseKey_(hKey)
  EndIf
EndProcedure


CatchImage(1, ?Icon_Connect_ON, ?Icon_Connect_ON_End-?Icon_Connect_ON)
CatchImage(2, ?Icon_Connect_OFF, ?Icon_Connect_OFF_End-?Icon_Connect_OFF)

CatchImage(7, ?Icon_Pref, ?Icon_Pref_End-?Icon_Pref)
CatchImage(8, ?Icon_Close, ?Icon_Close_End-?Icon_Close)
CatchImage(9, ?Icon_Ok, ?Icon_Ok_End-?Icon_Ok)
CatchImage(10, ?Icon_help, ?Icon_help_End-?Icon_help)


If CreatePopupMenu(1)
  MenuItem(1,"Настройки")
  MenuItem(5,"О программе")
  MenuBar()
  MenuItem(3,"Выход")
EndIf

TestFileAndKey()
ReadInfo(@ProgInfo)
WindowInfo() 

InfoWin\AnimMax=ProgInfo\PrOkno
InfoWin\Window =1
HideInfoWindowState=1
If ProgInfo\VspOknoType=3
  HideInfoWindowState=0
  InfoWin\AnimState=0
  If CreateThread(@AnimateWindow_Thread(), @InfoWin)
    HideInfoWindowState=0
  EndIf
  
EndIf


OpenWindow(2, 0, 0, 0, 0, "", #PB_Window_Invisible) ; Окно для трея

Define i, Event, Gadget, Menu, Type, Window, HideInfoWindowState_Temp, Temp
Define SpinTest.s, SpinLen, SpinChar.u, Sp_t, TempSp.s

;- Открываем окно

If OpenWindow(0, 0, 25, 358, 304, "Настройки", #PB_Window_SystemMenu|#PB_Window_Invisible|#PB_Window_ScreenCentered) 
  CompilerIf #PB_Compiler_Version<430 
    CreateGadgetList(WindowID(0)) 
  CompilerEndIf 
  
  Frame3DGadget(1, 10, 10, 335, 150, "Всплывающее окно")
  OptionGadget(2, 20, 30, 110, 15, "Не отображать")
  OptionGadget(3, 20, 50, 215, 15, "Отображать при наличии соединения")
  OptionGadget(4, 20, 70, 205, 15, "Отображать при наличии трафика")
  OptionGadget(5, 20, 90, 190, 15, "Всегда отображать")
  CheckBoxGadget(6, 20, 115, 320, 15, "Прятать/отображать по двойному клику по значку в трее")
  TextGadget(7,20,140,104,15,"Прозрачность окна")
  TrackBarGadget(8,124,136,200,20,50,255)
  ButtonGadget(9, 195, 225, 150, 24, "Сброс истории трафика")
  CheckBoxGadget(10, 20, 230, 165, 15, "Автозагрузка программы")
  CheckBoxGadget(11,20,170,144,15,"Допустимый лимит,  Мб",#PB_Text_Border)
  SpinGadget(12,180,166,50,20,10,10000,#PB_Spin_Numeric)
  
  SpinGadget(17,300,40,30,20,0,90,#PB_Spin_Numeric|#PB_Spin_ReadOnly)
  GadgetToolTip(17,"Через какое время после установки соединения или появления трафика отобразить окошко над треем")
  SpinGadget(18,300,70,30,20,0,90,#PB_Spin_Numeric|#PB_Spin_ReadOnly)
  GadgetToolTip(18,"Через какое время после пропадания связи с сетью или исчезновения трафика  скрыть окошко над треем")
  
  TextGadget(19,20,200,100,15,"Учитывать трафик")
  ComboBoxGadget(20,140,194,90,20)
  AddGadgetItem(20,-1,"Общий")
  AddGadgetItem(20,-1,"Входящий")
  AddGadgetItem(20,-1,"Исходящий")
  
  Frame3DGadget(#PB_Any,240,164,100,54,"Трафик")
  OptionGadget(24,250,178,50,16,"WAN") : GadgetToolTip(24,"Для соединений, активирующихся с помощью ярлыка")
  OptionGadget(25,250,198,50,16,"LAN") : GadgetToolTip(25,"Для соединений, без активации")
  
  
  Define Im4=CreateImage(#PB_Any,358,2)
  If StartDrawing(ImageOutput(Im4))
    Line(0,0, 358,1 ,RGB(120, 120, 120))
    Line(0,1, 358,1 ,RGB(255, 255, 255))
    StopDrawing()
    ImageGadget(#PB_Any,0,260,358,2,ImageID(Im4))
  EndIf
  
  IconButtonGadget(21, 50, 270, 90, 28, "Сохранить ",ImageID(9),#BS_RIGHT)
  IconButtonGadget(22, 220, 270, 80, 28, "Отмена  ",ImageID(8),#BS_RIGHT)
  
  
  Gosub SetDataToWinPref
  
  
  
  
  SetWindowCallback(@WindowCallback()) 

  
  For i=1 To 10
    If AddSysTrayIcon(1, WindowID(2), ImageID(2))
      Break
    Else
      If i=10
        MessageRequester("CountTraffic", "Не удалось создать значок в трее", 16)
        End
      EndIf
      Delay(200)
    EndIf
  Next i
  
  SetTimer_(WindowID(2),1,1000,@CountTraf())
  
  
  ;- Начало цикла 
  Repeat 
    Event=WaitWindowEvent()
    Gadget=EventGadget()
    Menu=EventMenu()
    Type=EventType()
    Window=EventWindow()
    
    If  Event = 12502 ; События баллона
      If EventlParam()=#NIN_BALLOONUSERCLICK ; Клик по баллону
        If AnimateWindow_Thread_State<>1
          InfoWin\AnimState=0
          If CreateThread(@AnimateWindow_Thread(), @InfoWin)
            HideInfoWindowState=0
          EndIf
        EndIf
      EndIf
    EndIf
    
    
    If Event = #PB_Event_SysTray 
      If Type = #PB_EventType_RightClick
        DisplayPopupMenu(1, WindowID(2))
      ElseIf Type = #PB_EventType_LeftDoubleClick
        If ProgInfo\VspOknoState=1
          HideInfoWindowState_Temp=HideInfoWindowState!1
          If AnimateWindow_Thread_State<>1
            InfoWin\AnimState=HideInfoWindowState_Temp
            If CreateThread(@AnimateWindow_Thread(), @InfoWin)
              HideInfoWindowState=HideInfoWindowState_Temp
            EndIf
          EndIf 
        EndIf
      EndIf
    EndIf  
    
    
    If Event = #PB_Event_Menu
      Select Menu
        Case 1
          Gosub SetDataToWinPref
          HideWindow(0,0)
        Case 3
          Break
        Case 5
          
          MessageRequester("О Программе "+Chr(34)+"CountTraffic"+Chr(34), "Эта программа предназначена для определения количества"+Chr(10)+"затраченного трафика за определённый промежуток времени.", #MB_OK|#MB_ICONINFORMATION)
      EndSelect
    EndIf
    
    If Window=0
      
      If Event = #PB_Event_Gadget
        Select Gadget
          Case 2 To 5
            Temp=Gadget-2
            
            If Temp=0 And HideInfoWindowState=0
              InfoWin\AnimState=1
              If CreateThread(@AnimateWindow_Thread(), @InfoWin)
                HideInfoWindowState=1
              EndIf
            ElseIf Temp=3 And HideInfoWindowState=1
              HideInfoWindowState=0
              InfoWin\AnimState=0
              If CreateThread(@AnimateWindow_Thread(), @InfoWin)
                HideInfoWindowState=0
              EndIf
            EndIf
            
            If Temp=0
              DisableGadget(17,1)
              DisableGadget(18,1)
            Else
              DisableGadget(17,0)
              DisableGadget(18,0)
            EndIf
            
            HideGadget(17,1)  : HideGadget(17,0)
            HideGadget(18,1)  : HideGadget(18,0)
            
          Case 8
            SetLayeredWindowAttributes_(WindowID(1), 0, GetGadgetState(8), 2) 
          Case 9
            If MessageRequester("", "Вы действительно хотите очистить историю трафика?", #MB_YESNO|#MB_ICONQUESTION|#MB_DEFBUTTON2)=#IDYES
              ProgInfo\AllTrafic=0
              ProgInfo\All_InTrafic=0
              ProgInfo\All_OutTrafic=0
              ProgInfo\LimitCountMessage=0
              ProgInfo\InTraffSave=0
              ProgInfo\OutTraffSave=0
              SetGadgetText(42,"0")
              SetGadgetText(44,"0")
              SetGadgetText(46,"0")
              SetGadgetText(48,"0")
              SetGadgetColor(42,#PB_Gadget_FrontColor,0)
              SetGadgetColor(44,#PB_Gadget_FrontColor,0)
              SetGadgetColor(46,#PB_Gadget_FrontColor,0)
              SetGadgetColor(48,#PB_Gadget_FrontColor,0)
            EndIf
            
          Case 11
            Temp=GetGadgetState(11)!1
            DisableGadget(12,Temp)
            HideGadget(12,1)
            HideGadget(12,0)
            DisableGadget(19,Temp)
            DisableGadget(20,Temp)
            
          Case 12
            Select Type
              Case #PB_EventType_Change
                SpinTest=GetGadgetText(12)
                SpinLen=Len(SpinTest)
                For i=1 To SpinLen
                  SpinChar=Asc(Mid(SpinTest,i,1))
                  If SpinChar <'0' Or SpinChar>'9'
                    SetGadgetText(12,Str(GetGadgetState(12)))
                    Break
                  EndIf
                Next i
                
              Case 1
                Sp_t=GetGadgetState(12)
                If Sp_t>=10 And Sp_t<10000
                  TempSp=Left(Str(Sp_t),Len(Str(Sp_t))-1 )
                  TempSp=TempSp+"0"
                  Sp_t=Val(TempSp)
                EndIf
                
                If sp_t<10000
                  sp_t=sp_t+10
                EndIf
                SetGadgetState(12,sp_t)
                SetGadgetText(12,Str(sp_t))
              Case -1
                
                Sp_t=GetGadgetState(12)
                If Sp_t>=10 And Sp_t<10000
                  TempSp.s=Left(Str(Sp_t),Len(Str(Sp_t))-1 )
                  TempSp=TempSp+"0"
                  Sp_t=Val(TempSp)
                EndIf
                
                If sp_t>10
                  sp_t=sp_t-10
                Else
                  sp_t=10
                EndIf
                SetGadgetState(12,sp_t)
                SetGadgetText(12,Str(sp_t))
                
            EndSelect
            
          Case 21 ; Сохранить
            HideWindow(0,1) 
            
            ProgInfo\VspOknoType=2
            For i=2 To 5
              Temp=GetGadgetState(i)
              If Temp=1
                ProgInfo\VspOknoType=i-2
                Break
              EndIf
            Next i
            
            ProgInfo\VspOknoState=GetGadgetState(6)
            ProgInfo\PrOkno=GetGadgetState(8)
            InfoWin\AnimMax=ProgInfo\PrOkno
            ProgInfo\AutoRunState=GetGadgetState(10)
            ProgInfo\LimitState=GetGadgetState(11)
            If ProgInfo\Limit<>GetGadgetState(12)
              ProgInfo\Limit=GetGadgetState(12)
              ProgInfo\LimitCountMessage=0
              SetGadgetColor(42,#PB_Gadget_FrontColor,0)
              SetGadgetColor(44,#PB_Gadget_FrontColor,0)
              SetGadgetColor(46,#PB_Gadget_FrontColor,0)
              SetGadgetColor(48,#PB_Gadget_FrontColor,0)
            EndIf
            
            ProgInfo\VspTime1=GetGadgetState(17)
            ProgInfo\VspTime2=GetGadgetState(18)
            ProgInfo\LimitTypeTrafic=GetGadgetState(20)
            ProgInfo\TypeTrafic=GetGadgetState(25)
            
            SavePref_Flag=#True
            SaveInfo(@ProgInfo)
            If ProgInfo\AutoRunState=1 ; Автозагрузка
              ProgramAtStartup(#True)
            Else
              ProgramAtStartup(#False)
            EndIf
            
          Case 22 ; Отмена
            HideWindow(0,1)  
            
        EndSelect
      EndIf
      
      If Event=#PB_Event_CloseWindow
        HideWindow(0,1)
        
      EndIf
      
    EndIf
    
  Until Event=#PB_Event_CloseWindow And Window=2
  
  SavePref_Flag=#True
  SaveInfo(@ProgInfo)
  
  KillTimer_(WindowID(2),1)
  
EndIf
End

;- Подпрограммы
SetDataToWinPref:
SetGadgetState(6,ProgInfo\VspOknoState)
If IsGadget(2+ProgInfo\VspOknoType) And GadgetType(2+ProgInfo\VspOknoType)=#PB_GadgetType_Option
  SetGadgetState(2+ProgInfo\VspOknoType, 1)
Else
  SetGadgetState(2, 1) : ProgInfo\VspOknoType=0
EndIf
SetGadgetState(8,ProgInfo\PrOkno) : SetLayeredWindowAttributes_(WindowID(1), 0, ProgInfo\PrOkno, 2) 
SetGadgetState(10,ProgInfo\AutoRunState)

SetGadgetState(11,ProgInfo\LimitState)
SetGadgetState(12,ProgInfo\Limit)
SetGadgetText(12,Str(ProgInfo\Limit))
DisableGadget(12,ProgInfo\LimitState!1)
DisableGadget(19,ProgInfo\LimitState!1)
DisableGadget(20,ProgInfo\LimitState!1)

SetGadgetState(17,ProgInfo\VspTime1)
SetGadgetText(17,Str(ProgInfo\VspTime1))
SetGadgetState(18,ProgInfo\VspTime2)
SetGadgetText(18,Str(ProgInfo\VspTime2))

If ProgInfo\VspOknoType=0
  DisableGadget(17,1)
  DisableGadget(18,1)
Else
  DisableGadget(17,0)
  DisableGadget(18,0)
EndIf

SetGadgetState(20,ProgInfo\LimitTypeTrafic)

If ProgInfo\TypeTrafic=0
  SetGadgetState(24,1)
Else
  SetGadgetState(25,1)
EndIf

Return


;- Дата секция
DataSection
  
  Icon_Connect_ON:
  IncludeBinary "Files\Connect_ON.ico"
  Icon_Connect_ON_End:
  
  Icon_Connect_OFF:
  IncludeBinary "Files\Connect_OFF.ico"
  Icon_Connect_OFF_End:
  
  Icon_Pref:
  IncludeBinary "Files\Pref.ico"
  Icon_Pref_End:
  
  Icon_Close:
  IncludeBinary "Files\Close.ico"
  Icon_Close_End:
  
  Icon_help:
  IncludeBinary "Files\help.ico"
  Icon_help_End:
  
  Icon_Ok:
  IncludeBinary "Files\Ok.ico"
  Icon_Ok_End:
  
EndDataSection
; IDE Options = PureBasic 6.00 LTS (Windows - x86)
; CursorPosition = 724
; FirstLine = 708
; Folding = ---
; Optimizer
; EnableThread
; EnableXP
; UseIcon = Files\Значок.ico
; Executable = CountTraffic.exe